;-------------------------------------------------------------------------------
;  GetScreenHeight Procedure returns result in EAX
;  GetScreenWidth  Procedure returns result in EAX
;
;  This source and assosciated binary code is 
;  Copyright  2001 by Ramon Sala
;  Exclusive permission to use these functions has
;  been given to the GeneSys project
;
;  Written by Ramon Sala
;
.386
.model flat,stdcall
option casemap:none

Include	\GeneSys\include\windows.inc
Include	\GeneSys\include\kernel32.inc
Include	\GeneSys\include\gdi32.inc
Include	\GeneSys\include\shell32.inc
Include	\GeneSys\include\user32.inc

IncludeLib \GeneSys\lib\kernel32.lib
Includelib \GeneSys\lib\gdi32.lib
Includelib \GeneSys\lib\shell32.lib
Includelib \GeneSys\lib\user32.lib

.Code

GetScreenHeight Proc Uses Ebx
	Local abd:APPBARDATA

	Invoke CreateCompatibleDC, NULL
	Push Eax ;Saves device context
	Invoke GetDeviceCaps, Eax, VERTRES
	Mov Ebx, Eax
	Pop Eax ;Restores device context
	Invoke DeleteDC, Eax
	Mov abd.cbSize, SizeOf APPBARDATA
	Invoke SHAppBarMessage, ABM_GETTASKBARPOS, Addr abd
	Invoke SHAppBarMessage, ABM_GETSTATE, Addr abd
	Cmp Eax, ABS_ALWAYSONTOP
	Jne @F
	Cmp abd.rc.top, 0
	Jle @F
	Mov Eax, abd.rc.top
	Ret
@@:	Mov Eax, Ebx
	Ret
GetScreenHeight EndP

GetScreenWidth Proc Uses Ebx
	Local abd:APPBARDATA

	Invoke CreateCompatibleDC, NULL
	Push Eax ;Saves device context
	Invoke GetDeviceCaps, Eax, HORZRES
	Mov Ebx, Eax
	Pop Eax ;Restores device context
	Invoke DeleteDC, Eax
	Mov abd.cbSize, SizeOf APPBARDATA
	Invoke SHAppBarMessage, ABM_GETTASKBARPOS, Addr abd
	Invoke SHAppBarMessage, ABM_GETSTATE, Addr abd
	Cmp Eax, ABS_ALWAYSONTOP
	Jne @F
	Cmp abd.rc.left, 0
	Jle @F
	Mov Eax, abd.rc.left
	Ret
@@:	Mov Eax, Ebx
	Ret
GetScreenWidth EndP

End
